<script setup>
import { computed, shallowRef, defineModel } from 'vue';
import Game from '../../game';
import FilterBox from '../components/filterbox.vue';
import { gameEvents } from '../../events';
import { useRollOver } from '../../store/popups';
import { useRowColors } from '../composables/use-row-colors';
import { canTarget } from '@/values/consts';

/**
 * @property {Inventory} inv - the inventory object.
 * @property {boolean} take - whether to display take button.
 * @property {boolean} selecting - inventory is selection only. sell-all & size information hidden.
 * @property {string[]} types - item types to display.
 */
const props = defineProps(['inv',
	'take',
	'kinds',
	'state',
	'selecting', 'nosearch', 'types', 'combat']);

const model = defineModel();

const { itemOver } = useRollOver();

const filtered = shallowRef(null);

const gridRef = shallowRef();

const cols = useRowColors( gridRef );

const sellAll = () => {

	const inv = props.inv;
	const items = filtered.value;
	for (let i = items.length - 1; i >= 0; i--) {
		gameEvents.emit('sell', items[i], inv, items[i].count);
	}

}

const countStr = (n) => { return n > 1 ? ' (' + Math.floor(n) + ')' : ''; }

/**
 * Test if item can be added to USER inventory.
 */
const canAdd = (it) => {
	return props.state.inventory.canAdd(it);
}

const canEquip = (it) => {
	return Game.canEquip(it)
}

const doSell = (it, count = 1) => {

	if (it.count > 0) {
		gameEvents.emit('sell', it, props.inv, count);
	}

}

const doUse = (it) =>{

	it.onUse( Game, props.inv );
}

const onTake = (it) => {

	if ( props.state?.inventory.add(it) ){
		props.inv.remove(it);
	}

}


const baseItems = computed(() => {

	const types = props.types;
	const items = types ?
				props.inv.items.filter(it=>types.includes(it.type))
					: props.inv.items;
	
	if ( props.kinds && props.kinds.length >0 ){
		return items.filter(it=>canTarget(props.kinds, it));
	}
	return items;

});

const playerFull = computed(() => { return Game.state.inventory.full(); });

</script>


<template>
<div class="inventory">

	<span class="top">
	<FilterBox v-if="!nosearch" v-model="filtered" :items="baseItems" min-items="7" />
	<span v-if="!selecting && !combat">
		<span v-if="inv.max > 0">{{ inv.items.length + ' / ' + Math.floor(inv.max.value) + ' Used' }}</span>
		<button v-if="inv.count > 0" @click="sellAll">Sell All</button>
	</span>
	</span>

	<div class="item-table" ref="gridRef">

	<div class="item separate" v-for="(it,ind) in (nosearch ? baseItems : filtered)"
		:key="it.id"
		:class="ind%(2*cols)<cols ? 'odd-row':''">
		<span class="item-name" @mouseenter.capture.stop="itemOver($event, it)">
			{{ it.name + countStr(it.count) }}</span>


		<template v-if="!selecting && !combat">

			<button v-if="it.equippable && canEquip(it)" class="item-action"
				@click="gameEvents.emit('equip', it, inv)">Equip</button>
			<button v-if="it.use" class="item-action" @mouseenter.capture.stop="itemOver($event, it)" @click="doUse(it, inv)">Use</button>
			<button v-if="take && canAdd(it)" class="item-action" @click="onTake(it)">Take</button>

			<button class="item-action"
				@click="doSell(it)"
				@mouseenter.capture.stop="itemOver($event, it)">Sell</button>
	
			<button v-if="it.count > 1" class="item-action" @click="doSell(it, it.count)" @mouseenter.capture.stop="itemOver($event, it)">Sell All</button>

		</template>
		<template v-if="!selecting && combat">

		<button v-if="it.use" class="item-action"
			@mouseenter.capture.stop="itemOver($event, it)"
			@click="doUse(it,inv)">Use</button>

		</template>
		<template v-if="selecting">
			<button class="item-action"  @click="model = it">Select</button>
		</template>
	</div>
</div>

<div v-if="playerFull" class="warn-text">Inventory Full</div>
</div>
</template>


<style scoped>
.inventory {
	display: flex;
	flex-direction: column;
	width: 100%;
	height: 100%;
	min-height: 0;
}

.top {
	padding: var(--tiny-gap);
	padding-top: var(--sm-gap);
}

.filter-box {
	display: inline;
	font-size: 0.9rem;
}

/*.table-div {
	display: grid; grid-template-columns: 1fr 1fr;
	flex-grow: 1;
	height:100%;
}*/

.item-table {
	flex-grow: 1;
	flex-shrink: 1;
	overflow-y: auto;
	min-height: 0;
	margin: 0;
	padding: 0;
	display: grid;
	grid-template-columns: repeat(auto-fit, minmax(12rem, 1fr));
	grid-auto-rows: min-content;

}

.item-name {
	flex-grow: 1;
}

.item-table>.odd-row {
	background: var(--odd-list-color);
}

.item-table .item {
	padding: var(--sm-gap);
	align-items: center;
}

.item .item-action {
	margin: var(--tiny-gap);
}
</style>